
#include "arch.h"
//#include "dist.h"
#include "error.h"

#include <stream.h>
#include <stdlib.h>
#include <string.h>

float distribution_cmd(Dataset* data, Distribution* dist, Nodeset* nodeset) {
    data->distribute( dist->Type(), nodeset->procs_num() ) ;
    return 0 ;
}

float synchronize() {
    return 0 ;
}

float estimate(Nodeset& nodeset, Linkset& linkset, Dataset& dataset, 
		Distribution& distribution) {

/*

    Dataset* data = dataset.locate("Jacobi") ;

    cout << "Simulator ........" << endl << endl ;

    Nodeset* node = nodeset.locate("Nodeset0") ;
    cout << "calculate : " << node->calculate(data) << endl ;

    float cost = 0;

//  Send Jacobi from Nodeset2 to Nodeset1
    cost += data->transmit(nodeset, "Nodeset2", "Nodeset1") ;

    cost += data->transmit(nodeset, "Nodeset1", "Nodeset0") ;
    cost += data->update(nodeset, "Nodeset0") ;

    cout << "Total cost is estimated to be : " << cost << " s" <<endl ;
*/

#ifdef DEBUG
cout << "In estimate ... " << endl ;
#endif

    char comd[20] ;
    char s1[10], s2[10] ;
    char name1[40], name2[40], name3[40] ;

    ifstream exec_file("exec.scrpt") ;

    float cost = 0 ;
    while (!exec_file.eof()) {
	if (exec_file >> comd) {
	    if (!strcmp(comd, "Use")) {
		exec_file >> comd >> name1 >> s1 >> name2 ;
		if (strcmp(s1, "on")) {
		    cerr << "Sorry: Wrong Execution Script" << endl ;
		    exit(-1) ;
		}

		Dataset* data = dataset.locate(name2) ;
		if ( !data ) error(name2) ;
		Distribution* dist = distribution.locate(name1) ;
		if ( !dist ) error(name1) ;
		cost += distribution_cmd(data, dist, &nodeset) ;
	    }
 	    else if (!strcmp(comd, "Send")) {
		exec_file >> name1 >> s1 >> name2 >> s2 >> name3 ;
		if (strcmp(s1, "from") || strcmp(s2, "to")) {
		    cerr << "Sorry: Wrong Execution Script" << endl ;
                    exit(-1) ;
                }

		Dataset* data = dataset.locate(name1) ;
		if ( !data ) error(name1) ;
		cost += data->transmit(nodeset, name2, name3) ;
	    }
            else if (!strcmp(comd, "Move")) {
                exec_file >> name1 >> s1 >> name2 >> s2 >> name3 ;
                if (strcmp(s1, "from") || strcmp(s2, "to")) {
                    cerr << "Sorry: Wrong Execution Script" << endl ;
                    exit(-1) ;
                }

                Dataset* data = dataset.locate(name1) ;
		if ( !data ) error(name1) ;
                cost += data->datamove(nodeset, name2, name3) ;
            }
	    else if (!strcmp(comd, "Compute")) {
		exec_file >> name1 >> s1 >> name2 ;
                if (strcmp(s1, "on")) {
		    cerr << "Sorry: Wrong Execution Script" << endl ;
                    exit(-1) ;
                }

		Dataset* data = dataset.locate(name1) ;
		if ( !data ) error(name1) ;
		cost += data->update(nodeset, name2) ;
	    }
	    else if (!strcmp(comd, "Synchronize")) {
		cost += synchronize() ;
	    }
	    else {
                    cerr << "Sorry: Wrong Execution Script" << endl ;
                    exit(-1) ;
            }
#ifdef DEBUG
cout << " cost =  " << cost << endl ;
#endif

	}
    }

    ofstream result_file("results.out") ;

    result_file << "Total cost is estimated to be : " << cost << " s" << endl ;
    cout << "Total cost is estimated to be : " << cost << " s" << endl ;

    return cost ;
}
